; PARABEL.LSP Copyright (c) 1988, 1999 by Martin Vogel
;
; Zeichnet eine quadratische Parabel
;
; Wahlweise kann die Parabel durch drei Punkte bestimmt werden oder durch
; die Angabe von zwei Punkten und der Tangente im Startpunkt.
; Die Parabelgleichung wird im Textfenster von AutoCAD ausgegeben.


(Defun C:Parabel (/ p0 p02 p1 p12 pm xm ym pm2 t0 w a b c d n x dx tuwas)
  (SetVAR "CmdEcho" 0)
  (Initget 7)
  (Setq p0 (getpoint "\nAnfangspunkt: "))
  (SetQ x (Car p0))
  (Setq p1 (getpoint "\nEndpunkt: "))
  (Initget 7 "T t S s")
  (Setq pm (getpoint "\nTangentenrichtung, Stich oder <Hilfspunkt>"))
  (IF (or (eq pm "t") (eq pm "T"))
      (PROGN
        (Setq t0 (/ (sin (setq w (getangle p0 "\nTangentenrichtung: ")))
                    (cos w)))
        (setq c (- (car p1) x))
        (setq a (/ (- (cadr p1) (* t0 c) (cadr p0)) (* c c)))
        (setq b (- t0 (* 2 a x)))
        (setq c (+ (cadr p0) (* a x x) (- (* t0 x)))))
      (PROGN
        (IF (or (eq pm "s") (eq pm "S"))
              (setq pm (list (/ (+ x (car p1)) 2)
                             (+ (/ (+ (cadr p0) (cadr p1)) 2)
                                (getreal "Stich: ")))))
        (setq p02 (* x x))
        (setq pm2 (* (car pm) (car pm)))
        (setq p12 (* (car p1) (car p1)))
        (setq D
         (- (+ (* p02 (car pm)) (* x p12) (* pm2 (car p1)))
            (+ (* p12 (car pm)) (* (car p1) p02) (* pm2 x))))
         (setq a  (/ (- (+ (* (cadr p0) (car pm))
                           (* x (cadr p1))
                           (* (cadr pm) (car p1)))
                        (+ (* (cadr p1) (car pm))
                           (* (car p1) (cadr p0))
                           (* (cadr pm) x)))
                     D))
         (setq b  (/ (- (+ (* p02 (cadr pm))
                           (* (cadr p0) p12)
                           (* pm2 (cadr p1)))
                        (+ (* p12 (cadr pm))
                           (* (cadr p1) p02)
                           (* pm2 (cadr p0))))
                     D))
         (setq c  (/ (- (+ (* p02 (car pm) (cadr p1))
                           (* (car p0) (cadr pm) p12)
                           (* (cadr p0) pm2 (car p1)))
                        (+ (* p12 (car pm) (cadr p0))
                           (* (car p1) (cadr pm) p02)
                           (* (cadr p1) pm2 (car p0))))
                   D))))
  (Write-Line (StrCat "\nParabelgleichung: " (rtos a 2) "*x^2 + "
                      (rtos b 2) "*x + " (rtos c 2)))
  (InitGet 7)
  (Setq n (GetInt "\nAnzahl der Teilstuecke: "))
  (setq dx (/ (- (car p1) x) n))
  (Setq tuwas '(Command "PLINIE" p0))
  (Repeat n (SetQ tuwas
            (Append Tuwas
                    (List(List 'Quote
                               (List (SetQ x (+ x dx))
                                     (+ (* a x x) (* b x) c)))))))
  (SetQ Tuwas (Append Tuwas '("")))
  (Eval Tuwas)
  (Command "PEDIT" "L" "A" "X")
  (terpri)
)

