; SKPFEIL.LSP Copyright (c) 1988, 1999 by Martin Vogel
;
; Zeichnet einen beschrifteten Skalenpfeil.
;
; Die Beschriftung beginnt bei einem Anfangswert (z.B. 100),
; der so lange um ein Inkrement (z.B. 50) erhoeht wird, bis
; ein Endwert (z.B. 250) erreicht oder ueberschritten ist.
; Die geometrische Laenge der beschrifteten Intervalle und die
; Anzahl der Unterteilungen jedes Intervalls kann frei
; gewaehlt werden.
; Der Text kann in Pfeilrichtung links oder rechts angeordnet werden
; und laesst sich linksbuendig, zentriert oder rechtsbuendig
; ausrichten.


(DEFUN C:SKPFEIL ()
 (SETVAR "CMDECHO" 0)                  ;Muss ganz oben stehen
 (INITGET 1)                           ;Verbot von Leereingaben
 (SETQ pi2 (* pi 2.0)
       pi5 (* pi 0.5)
       U   (GETPOINT "\nUrsprungspunkt: ")
       A   (GETANGLE U "\nAchsrichtung: ")
       S   (IF (EQ "R" (STRCASE (SUBSTR
                         (GETSTRING "\nSkala nach (L)inks oder (R)echts ? ")
                         1 1)))
               (- A pi5)
               (+ A pi5))
       WA  (GETREAL "\nSkalenanfangswert: ")
       WE  (GETREAL "\nSkalenendwert: ")
       WI  (ABS (GETREAL "\nInkrement: "))
       WI  (IF (> WE WA) WI (- WI))
       NK  (GETINT "\nAnzahl Nachkommastellen: ")
       IL  (GETDIST "\nIntervallaenge: ")
       UT  (GETINT  "\nAnzahl Intervallteilungen: ")
       TR  (GETANGLE U "\nTextrichtung: ")
       TS  (GETVAR "TEXTSIZE")
       TO  (STRCASE (SUBSTR (GETSTRING
            "\nTextorientierung:\n (L)inks, (Z)entriert oder (R)echts ? ")
            1 1))
 )
 (COMMAND "PLINIE"
          U
          "B" 0 0
          (SETQ M (POLAR U A
                  (* IL (+ (SETQ IZ (FIX (+ (/ (- WE WA) WI) 0.5))) 0.5))))
          "B" (/ (* 2.0 TS) 3.0) 0
          (POLAR M A TS)
          "")
 (REPEAT (1+ IZ)
   (COMMAND "LINIE"
            U
            (POLAR U S TS)
            "")
;Wer hat Lust, die beiden IF-Zweige zusammenzufassen?
   (IF (= TO "L")
       (COMMAND "TEXT"
                (POLAR (POLAR U S (* 2 TS)) (- TR pi5) (* TS 0.5))
                TS
                (/ (* 180 TR) pi)
                (RTOS WA 2 NK))
       (COMMAND "TEXT"
                TO
                (POLAR (POLAR U S (* 2 TS)) (- TR pi5) (* TS 0.5))
                TS
                (/ (* 180 TR) pi)
                (RTOS WA 2 NK)))
   (IF (OR (AND (> WI 0) (< WA (- WE (/ WI 2.0))))
           (AND (< WI 0) (> WA (- WE (/ WI 2.0)))))
       (PROGN
         (SETQ M U)
         (REPEAT (1- UT)
                 (COMMAND "LINIE"
                          (SETQ M (POLAR M A (/ IL (FLOAT UT))))
                          (POLAR M S (/ TS 2.0))
                          ""))))
   (SETQ WA (+ WA WI)
          U (POLAR U A IL))
 )
 (terpri)
)
